/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.part.RotationPart;
import jp.mosp.kintai.dao.CmRotationDao;
import jp.mosp.kintai.dto.CmRotationDto;
import jp.mosp.kintai.vo.ScheduleRotationCardVo;

/**
 * @author yoshida
 *
 */
public class ScheduleRotationCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_ROTATION_CARD_SHOW		= "K1215";	// 表示(追加)
	private static final String	CMD_ROTATION_CARD_SELECT	= "K1216";	// 表示(選択)
	private static final String	CMD_ROTATION_CARD_INSERT	= "K1217";	// 登録
	private static final String	CMD_ROTATION_CARD_UPDATE	= "K1218";	// 更新
																		
	
	/**
	 * コンストラクタ
	 */
	public ScheduleRotationCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_ROTATION_CARD_SHOW)) {
			// 表示(新規)
			show();
		} else if (cmd.equals(CMD_ROTATION_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_ROTATION_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_ROTATION_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ScheduleRotationCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		ScheduleRotationCardVo vo = (ScheduleRotationCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// コード区分プルダウンリスト作成
		vo.aryPltWorkType = part().worktype().getWorkTypeInfoArrayWithHoliday();
		vo.aryPltHoliday = VariousUtil.getApplicableFlagArray();
		vo.setParams(request);
	}
	
	@Override
	protected void show() {
		ScheduleRotationCardVo vo = (ScheduleRotationCardVo)getVo();
		vo.setDefaultValues();
		vo.setMode(ScheduleRotationCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		ScheduleRotationCardVo vo = (ScheduleRotationCardVo)getVo();
		// データの取得
		RotationPart rotation = (RotationPart)part().get(RotationPart.class.getCanonicalName());
		CmRotationDto dto = rotation.findForKey(userBasis.getKCode(), key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		// モード設定
		vo.setMode(ScheduleRotationCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		ScheduleRotationCardVo vo = (ScheduleRotationCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		RotationPart rotation = (RotationPart)part().get(RotationPart.class.getCanonicalName());
		// DAOの準備
		CmRotationDao dao = rotation.getCmRotationDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(userBasis.getKCode(), vo.getTxtRTCode()));
		// DTOの準備
		CmRotationDto dto = new CmRotationDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		dto.setKCode(userBasis.getKCode());
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(userBasis.getKCode(), dto.getRtCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(ScheduleRotationCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		CmRotationDto dto = (CmRotationDto)getSessionDto();
		ScheduleRotationCardVo vo = (ScheduleRotationCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		RotationPart rotation = (RotationPart)part().get(RotationPart.class.getCanonicalName());
		// DAOの準備
		CmRotationDao dao = rotation.getCmRotationDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(userBasis.getKCode(), vo.getTxtRTCode()));
		// DTOの準備
		vo.setDtoFields(dto);
		dto.setKCode(userBasis.getKCode());
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmRotationDto retDto = dao.findForKey(userBasis.getKCode(), dto.getRtCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(ScheduleRotationCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
}
